#include "arrow.h"
#include <string.h>
#include <dc.h>

//*** CArrow ***
CArrow::CArrow(TWindow* parent,char* atext,int x, int y, int aw, int ah, TColor acolor, int asize)
		 :TWindow(parent) {
  text = new char[strlen(atext)];
  strcpy(text,atext);
  Attr.X=x;
  Attr.Y=y;
  Attr.W= (aw<15) ? 15 : aw;
  Attr.H= (ah<15) ? 15 : ah;
  color=acolor;
  size=asize;
};

DEFINE_RESPONSE_TABLE1(CArrow, TWindow)
  EV_WM_ERASEBKGND,
END_RESPONSE_TABLE;

CArrow::~CArrow() {
  delete text;
}

void CArrow::Paint(TDC& adc, BOOL a, TRect& arec) {
  TWindow::Paint(adc,a,arec);
  if (Attr.W>Attr.H) {
	 TPen pen(color,size);
	 adc.SelectObject(pen);
	 int l=strlen(text);
	 adc.TextOut((Attr.W-10*l)>>1,0,text);
	 adc.MoveTo(0,Attr.H>>1);
	 adc.LineTo(((Attr.W-10*l)>>1)-5,Attr.H>>1);
	 adc.MoveTo(0,Attr.H>>1);
	 adc.LineTo(Attr.H>>1,0);
	 adc.MoveTo(0,Attr.H>>1);
	 adc.LineTo(Attr.H>>1,Attr.H);

	 adc.MoveTo(Attr.W,Attr.H>>1);
	 adc.LineTo(((Attr.W+10*l)>>1)+5,Attr.H>>1);
	 adc.MoveTo(Attr.W,Attr.H>>1);
	 adc.LineTo(Attr.W-(Attr.H>>1),0);
	 adc.MoveTo(Attr.W,Attr.H>>1);
	 adc.LineTo(Attr.W-(Attr.H>>1),Attr.H);
  } else {
	 TPen pen(color,size);
	 adc.SelectObject(pen);
	 int l=strlen(text);
	 char buf[2];
	 buf[1]=0;
	 for (int k=0;k<l;k++) {
		buf[0]=text[k];
		adc.TextOut(((Attr.W-15)>>1)+1,((Attr.H-15*l)>>1)+15*k-2,buf);
	 }
	 adc.MoveTo(Attr.W>>1,0);
	 adc.LineTo(Attr.W>>1,((Attr.H-10*l)>>1)-5);
	 adc.MoveTo(Attr.W>>1,0);
	 adc.LineTo(0,Attr.W>>1);
	 adc.MoveTo(Attr.W>>1,0);
	 adc.LineTo(Attr.W,Attr.W>>1);

	 adc.MoveTo(Attr.W>>1,Attr.H);
	 adc.LineTo(Attr.W>>1,((Attr.H+10*l)>>1)+5);
	 adc.MoveTo(Attr.W>>1,Attr.H);
	 adc.LineTo(0,Attr.H-(Attr.W>>1));
	 adc.MoveTo(Attr.W>>1,Attr.H);
	 adc.LineTo(Attr.W,Attr.H-(Attr.W>>1));
  }
}

BOOL CArrow::EvEraseBkgnd(HDC hDC)
{
  TDC dc(hDC);
  dc.TextRect(GetClientRect(), ::GetSysColor(COLOR_BTNFACE));
  return TRUE;
}

