#if !defined(__controls_h)
#define __controls_h

#define IDC_SIZESLIDER  135
#define IDC_SIZEEDIT    136
#define IDC_XYSLIDERX   137
#define IDC_XYSLIDERY   138
#define IDC_XYEDITX     139
#define IDC_XYEDITY     140
#define IDC_LONGSLIDER  141
#define IDC_LONGEDIT    142
#define IDC_XEDIT       143
#define IDC_XSLIDER     144

#include <stdio.h>
#include <math.h>
#include <edit.h>
#include <slider.h>
#include <gdiobjec.h>
#include "faisceau.rh"

enum eunit {nochange=-1, angle=0, distance=1};

//*** CXYControl ***
class CXYControl : public TWindow {
  TSlider *sliderx,*slidery;
  TEdit *editx,*edity;
  TStatic *staticx,*staticy;
  double xpos,ypos;
  int myIDC;
  int changed;
  double xmin,xmax,ymin,ymax;
  TWindow* parent;
  int hxpos,hypos;
  TBrush *BkBrush,*WhiteBrush;
  int precisionangle,precisiondistance;
  char *unitangle,*unitdistance;
  eunit aktunit;
  double faktordistance,faktorangle,length;
public:
  CXYControl(TWindow* aparent, int amyIDC, int x, int y,
	 int xywidth=175,int xyheight=200, const char far* xtitle=0,
	 const char far* ytitle=0,const char far* title=0,double length=0,
	 const char far* aunit1="mrad", const char far* aunit2="mm", int aprecision1=5,
	 int aprecision2=5, double afaktordistance=1000, double afaktorangle=1000, TModule* module=0);
  void GetData(double& x,double& y,int reset=0);
  void SetRange(double axmin,double axmax, double aymin, double aymax);
  void SetRuler(double ticGapX, double ticGapY, BOOL snapX = FALSE, BOOL snapY = FALSE);
  void SetPosition(double xpos,double ypos,int slider=0);
  int Changed() {return changed;};
  void ChangeUnit();
  void PrintDataX();
  void PrintDataY();
  LRESULT ResetChanged(WPARAM,LPARAM);
  void SetupWindow();
  HBRUSH EvCtlColor(HDC hDC, HWND hWndChild, UINT /*ctlType*/);
private:
  void SliderYChanged(UINT=0);
  void SliderXChanged(UINT=0);
  void ChangeXValue();
  void ChangeYValue();

  DECLARE_RESPONSE_TABLE(CXYControl);
};

//*** CXControl ***
class CXControl : public TWindow{
  double x;
  TSlider *slider;
  TEdit *edit;
  int myIDC,ok;
  double min,max;
  TWindow* parent;
  int hxpos;
  int changed;
  TBrush *BkBrush,*WhiteBrush;
public:
  CXControl(TWindow* aparent, int amyIDC, int x, int y,int xwidth,int xheight,
	 const char far* titlex , const char far* title=0);
  double GetData(int reset=0);
  void SetRange(double amin,double amax);
//  void SetRuler(double ticGapX, double ticGapY, BOOL snapX = FALSE, BOOL snapY = FALSE);
  void SetPosition(double xpos,int slidernew=1);
  void SetupWindow();
  int Changed() {return changed;};
  HBRUSH EvCtlColor(HDC hDC, HWND hWndChild, UINT /*ctlType*/);
private:
  void SliderChanged(UINT=0);
  void ChangeValue();

  DECLARE_RESPONSE_TABLE(CXControl);
};

//*** CSizeControl ***
class CSizeControl : public TWindow{
  double size;
  TSlider *slider;
  TEdit *edit;
  int myIDC,ok;
  double min,max;
  TWindow* parent;
  int hsizepos;
  int changed;
  TBrush *BkBrush,*WhiteBrush;
public:
  CSizeControl(TWindow* aparent, int amyIDC, int x, int y,
	 const char far* title = 0, TModule* module = 0);
  double GetData(int reset=0);
  void SetRange(double amin,double amax);
//  void SetRuler(double ticGapX, double ticGapY, BOOL snapX = FALSE, BOOL snapY = FALSE);
  void SetPosition(double sizepos);
  void SetupWindow();
  int Changed() {return changed;};
  HBRUSH EvCtlColor(HDC hDC, HWND hWndChild, UINT /*ctlType*/);
private:
  void SliderChanged(UINT=0);
  void ChangeValue();

  DECLARE_RESPONSE_TABLE(CSizeControl);
};

//*** CSLControl ***
class CSLControl : public TWindow {
  TSlider *sliderl,*sliders;
  TEdit *editl,*edits;
  int myIDC,ok;
  double minl,maxl,mins,maxs;
  TWindow* parent;
  int hsizepos,hlongpos;
  TBrush *BkBrush,*WhiteBrush;
public:
  CSLControl(TWindow* aparent, int amyIDC, int x, int y,
	 const char far* titles = 0,const char far* titlel = 0, TModule* module = 0);
  void GetData(double &asize,double &along);
  void SetRange(double amins, double amaxs, double aminl, double amaxl);
//  void SetRuler(double ticGapX, double ticGapY, BOOL snapX = FALSE, BOOL snapY = FALSE);
  void SetPosition(double sizepos,double longpos);
  void SetupWindow();
  HBRUSH EvCtlColor(HDC hDC, HWND hWndChild, UINT /*ctlType*/);
private:
  void SliderSChanged(UINT=0);
  void ChangeSValue();
  void SliderLChanged(UINT=0);
  void ChangeLValue();

  DECLARE_RESPONSE_TABLE(CSLControl);
};

#endif
