#include <applicat.h>
#include <decframe.h>
#include <messageb.h>
#include "laserdlg.h"
#include "faisceau.rh"

//*** LaserSimApp ***
class LaserSimApp : public TApplication {
public:
  LaserSimApp(const char far *name = "Simulation du faisceau laser") : TApplication(name) {};
  virtual void InitMainWindow();
};

void LaserSimApp::InitMainWindow() {
  EnableBWCC();
  EnableCtl3d();
  TMessageBar* mb = new TMessageBar();
  TDecoratedFrame *frame = new TDecoratedFrame( 0,Name,new TLaserDialog(mb) );
  frame->Insert(*mb, TDecoratedFrame::Bottom);
  frame->Attr.Style &=~(WS_MAXIMIZEBOX | WS_THICKFRAME );
  frame->Attr.W=985;
  frame->Attr.H=768;
  frame->SetIcon(this, IDI_LASER);
  frame->AssignMenu(LASERMENU);
  MainWindow=frame;
}

int OwlMain (int , char* []) {
  LaserSimApp App;
  return App.Run();
}

